package edu.uiuc.ncsa.myproxy.oa4mp.server;

import edu.uiuc.ncsa.security.core.Identifier;
import edu.uiuc.ncsa.security.delegation.server.ServiceTransaction;
import edu.uiuc.ncsa.security.delegation.storage.Client;
import edu.uiuc.ncsa.security.delegation.token.AuthorizationGrant;
import edu.uiuc.ncsa.security.util.pkcs.CertUtil;
import org.bouncycastle.jce.PKCS10CertificationRequest;

/**
 * <p>Created by Jeff Gaynor<br>
 * on May 17, 2011 at  3:26:21 PM
 */
public class DSTransaction extends ServiceTransaction {
    static final long serialVersionUID = 0xcafed00d2L;

    public DSTransaction(Identifier identifier) {
        super(identifier);
    }

    public DSTransaction(AuthorizationGrant ag) {
        super(ag);
    }

    public PKCS10CertificationRequest getCertReq() {
        if (certReq != null) {
            return certReq;
        }
        if (certReqString == null) {
            return null;
        }
        // Need to do it this way since cert requests are not actually serializable
        return CertUtil.fromStringToCertReq(getCertReqString());
    }

    public void setCertReqString(String certReqString) {
        if (certReqString == null && certReq != null) {
            certReqString = CertUtil.fromCertReqToString(certReq);
        }
        this.certReqString = certReqString;
    }

    public String getCertReqString() {
        return certReqString;
    }

    String certReqString;

    public void setCertReq(String certReq) {
        certReqString = certReq;
    }

    public void setCertReq(PKCS10CertificationRequest certReq) {
        this.certReq = certReq;
        certReqString = CertUtil.fromCertReqToString(certReq);
    }

    transient PKCS10CertificationRequest certReq;

    public Client getClient() {
        return client;
    }

    public void setClient(Client client) {
        this.client = client;
    }

    Client client;

    public String getUsername() {
        return username;
    }

    public void setUsername(String username) {
        this.username = username;
    }

    String username;
}
