package edu.uiuc.ncsa.myproxy.oa4mp.server.storage.filestore;

import edu.uiuc.ncsa.myproxy.oa4mp.server.DSTransaction;
import edu.uiuc.ncsa.myproxy.oa4mp.server.OA4MPConfigTags;
import edu.uiuc.ncsa.myproxy.oa4mp.server.util.TransactionConverter;
import edu.uiuc.ncsa.security.core.configuration.provider.CfgEvent;
import edu.uiuc.ncsa.security.delegation.token.TokenForge;
import edu.uiuc.ncsa.security.storage.FSProvider;
import org.apache.commons.configuration.tree.ConfigurationNode;

import javax.inject.Provider;
import java.io.File;

/**
 * <p>Created by Jeff Gaynor<br>
 * on 1/16/12 at  4:24 PM
 */
public class DSFSTransactionStoreProvider extends FSProvider<DSFSTransactionStore> implements OA4MPConfigTags {
    public DSFSTransactionStoreProvider(ConfigurationNode config, Provider<? extends DSTransaction> tp,
                                        Provider<TokenForge> tfp,
                                        TransactionConverter<DSTransaction> tc
                                        ) {
        super(config, FILE_STORE, TRANSACTIONS_STORE, tc);
        this.transactionProvider = tp;
        this.tokenForgeProvider = tfp;
    }

    Provider<? extends DSTransaction> transactionProvider;
    Provider<TokenForge> tokenForgeProvider;

    @Override
    public Object componentFound(CfgEvent configurationEvent) {
        if (checkEvent(configurationEvent)) {
            return super.componentFound(configurationEvent);
        }
        return null;
    }

    @Override
    protected DSFSTransactionStore produce(File dataPath, File indexPath) {
        return new DSFSTransactionStore(dataPath, indexPath, transactionProvider, tokenForgeProvider.get(), converter);
    }
}
